#ifndef montproduct_H
#define montproduct_H


#include "avx.h"

// note : montproduct with v4158_16 to multiply by R=2^16

static inline
__m256i montproduct( __m256i x , __m256i y )
{
  __m256i lo = _mm256_mullo_epi16( x , y );
  __m256i hi = _mm256_mulhi_epi16( x , y );
  __m256i d = _mm256_mullo_epi16( lo , _mm256_set1_epi16(15631) );
  __m256i e = _mm256_mulhi_epi16( d , _mm256_set1_epi16(4591) );
  return _mm256_sub_epi16(hi,e);
}


static inline
void montproduct_x2721_p16( int16* r, const int16* x )
{
  __m256i xx = _mm256_loadu_si256( (__m256i const *) x );
  __m256i rr = montproduct( xx , _mm256_set1_epi16(2721) );
  _mm256_storeu_si256( (__m256i *)r , rr );
}

#endif
